SystemOrganization addCategory: #'GMF-Window'!

ComposableModel subclass: #GMF
	instanceVariableNames: 'viewport surface textpane openFile saveFile generateCode association attribut element method reset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!GMF class methodsFor: 'dialogs' stamp: 'volosmat 11/26/2013 00:03'!
alertDialog: text 
	^ UITheme builder alert: text.! !

!GMF class methodsFor: 'specs' stamp: 'volosmat 11/28/2013 21:26'!
defaultSpec
	<spec: #default>
	^ SpecLayout composed
		newColumn: [:r | 
			r newRow: [ :col | 
				col add: #saveFileButton; 
				add: #openFileButton;
				add: #generateCodeButton;
				add: #elementButton;
				add: #attributButton;
				add: #methodButton;
				add: #associationButton;
				add: #resetButton.
				] height: 30;
			  newRow: [ :col1 | 
			  	col1 newColumn: [:col | col add: #viewMorph];
			  		 newColumn: [:col | col add: #textPane ] width: 150 ] ] ! !

!GMF class methodsFor: 'open' stamp: 'RostislavNovak 12/1/2013 22:20'!
open
	Drawer initialize.
	^ self new openWithSpec extent: 900@600! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/28/2013 21:56'!
association
	AssociationWindow new 
		openModal.
		
	self viewMorph changed.! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/26/2013 17:01'!
associationButton
	^association! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/28/2013 21:56'!
attribut
	AttributWindow new 
		openModal.
		
	self viewMorph changed.! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/26/2013 17:01'!
attributButton
	^attribut! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/28/2013 21:57'!
element
	ElementWindow new 
		openModal.
	
	self viewMorph changed.
! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/26/2013 17:01'!
elementButton
	^ element! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/28/2013 18:59'!
generateCode
	( Facade getClasses allSatisfy: [ :each | each metaModelClass validateClassName & each metaModelClass validateClass ] )
	ifTrue: [ Facade generate ];
	ifFalse: [ GMF alertDialog: 'Error in checking OntoUML rules or elements names.' ]! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/7/2013 12:52'!
generateCodeButton
	^ generateCode! !

!GMF methodsFor: 'initialization' stamp: 'volosmat 11/28/2013 21:25'!
initializePresenter

	openFile whenActionPerformedDo: [  self openFile ].
	element whenActionPerformedDo: [ self element ].
	attribut whenActionPerformedDo: [ self attribut ].
	method whenActionPerformedDo: [ self method ].
	association whenActionPerformedDo: [ self association ].
	generateCode whenActionPerformedDo: [ self generateCode ].
	reset whenActionPerformedDo: [ self reset ]! !

!GMF methodsFor: 'initialization' stamp: 'volosmat 11/28/2013 22:02'!
initializeWidgets 
		self instantiateModels: #(
		textpane	 	 	TextModel
		openFile		 	ButtonModel
		saveFile		 	ButtonModel
		#element   			ButtonModel
		#attribut   			ButtonModel
		#method   			ButtonModel
		#association  		ButtonModel
		#reset 				ButtonModel 
		generateCode   	ButtonModel
	).
		reset 
			label: 'Reset model';
			state: false.
		saveFile
			label: 'Save'; 
			state: false.
		openFile 
			label: 'Open'; 
			state: false.
		generateCode 
			label: 'Generate'; 
			state: false.
		element 
			label: 'Element'; 
			state: false.
		attribut 
			label: 'Attribut'; 
			state: false.
		method
			label: 'Method'; 
			state: false.
		association
			label: 'Association'; 
			state: false.
		
	textpane doItReceiver: self viewMorph.
	textpane text: 'Simple text class
--------------------------------
testAttr1: String[1]
testAttr2: Integer[1]
--------------------------------
testMethod(): bool'.


! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/28/2013 21:57'!
method
	MethodWindow new 
		openModal.
	
	self viewMorph changed.! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/26/2013 17:02'!
methodButton
	^method! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/7/2013 12:59'!
openFile
	! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/7/2013 12:52'!
openFileButton
	^openFile! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/28/2013 22:47'!
reset
	Facade clearData.
	Drawer surface
			drawDuring: [:canvas | Drawer surface clear: Color white].
	self viewMorph changed.! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/28/2013 21:23'!
resetButton
	^ reset! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/7/2013 12:53'!
saveFile
	! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/7/2013 12:52'!
saveFileButton
	^ saveFile! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/6/2013 23:19'!
textPane
	^textpane! !

!GMF methodsFor: 'text' stamp: 'volosmat 11/6/2013 22:46'!
title
	^ 'GMF in Pharo'! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/28/2013 22:07'!
viewMorph
	 ^ viewport ifNil: [  viewport := GMFViewMorph new. ].! !

Morph subclass: #GMFViewMorph
	instanceVariableNames: 'surface session derivation class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!GMFViewMorph methodsFor: 'session' stamp: 'volosmat 11/7/2013 22:41'!
checkSession
	session == Smalltalk session ifFalse: [ 
		"just reset the surface"
		surface := nil.
		session := Smalltalk session.
	]! !

!GMFViewMorph methodsFor: 'drawing' stamp: 'RostislavNovak 12/1/2013 22:22'!
drawOn: aCanvas
	self checkSession.
	surface
		ifNil: [ 
			surface := AthensCairoSurface extent: self extent asIntegerPoint.
			Drawer initialize.
			Drawer surface: surface.
			Drawer clear. ].
	Facade getDiagram notNil
		ifTrue: [ DrawDiagram draw: Facade getDiagram ].
	aCanvas drawImage: surface asForm at: bounds origin! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/1/2013 22:44'!
handleKeystroke: anEvent
	| keyValue |
	keyValue := anEvent keyValue.
	keyValue = 30
		ifTrue: [ Drawer moveSurfaceX: 0 Y: -10 ].	"up arrow"
	keyValue = 31
		ifTrue: [ Drawer moveSurfaceX: 0 Y: 10 ].	"down arrow"
	keyValue = 29
		ifTrue: [ Drawer moveSurfaceX: 10 Y: 0 ].	"right arrow"
	keyValue = 28
		ifTrue: [ Drawer moveSurfaceX: -10 Y: 0 ].	"left arrow"
	keyValue = 43
		ifTrue: [ Drawer setScale: 1.1 ].	"plus"
	keyValue = 45
		ifTrue: [ Drawer setScale: 0.9 ]	. "minus"
		
	DrawDiagram draw: Facade getDiagram.! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/1/2013 22:30'!
handlesMouseDown: anEvent 
    ^true! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/1/2013 22:26'!
handlesMouseOver: anEvent 
    ^true! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/1/2013 22:45'!
handlesMouseWheel: anEvent 
    ^true! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'volosmat 11/7/2013 22:41'!
initialize
	super initialize.
	session := Smalltalk session.
	
	self hResizing: #spaceFill;
		 vResizing: #spaceFill! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/2/2013 00:59'!
mouseDown: anEvent
	anEvent redButtonPressed
		ifTrue: [ derivation := anEvent cursorPoint ].	"click"
	anEvent yellowButtonPressed
		ifTrue: [ 
			derivation := anEvent cursorPoint.
			class := [ Facade getClasses detect: [ :e | e positionClass isIn: ((anEvent cursorPoint - anEvent targetPoint) - (Drawer shift)/Drawer scale) ] ]
				on: Error
				do: [ class := nil ].
			Transcript show: class name ].
	self changed! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/1/2013 22:26'!
mouseEnter: anEvent 
    anEvent hand newKeyboardFocus: self! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/1/2013 22:35'!
mouseLeave: anEvent
    anEvent hand newKeyboardFocus: nil! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/2/2013 00:15'!
mouseUp: anEvent
	anEvent redButtonChanged 
		ifTrue: [ derivation := (anEvent cursorPoint - derivation). Drawer moveSurfaceX: (derivation x)  Y: (derivation y) ].	"click"
	anEvent yellowButtonChanged
		ifTrue: [ derivation := (anEvent cursorPoint - derivation). class ifNotNil: [ class positionClass move: derivation ] ].
	self changed! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/1/2013 22:54'!
mouseWheel: anEvent
	anEvent direction = 'up'
		ifTrue: [ Drawer setScale: 1.1 ]
		ifFalse: [ Drawer setScale: 0.9 ].
	self changed! !

Object subclass: #AssociationWindow
	instanceVariableNames: 'start end startQuantity endQuantity name type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!AssociationWindow methodsFor: 'ok actions' stamp: 'volosmat 11/28/2013 21:54'!
doOnOK
	| data person attr method animal association position | 
	Drawer surface
		drawDuring: [:canvas | Drawer surface clear: Color white].
	data := DataModel new.
	person := Kind name: 'Person'.
	attr := Attribut
				name: 'birthNumber'
				dataType: 'string'
				quantity: '1'.
	person attributs add: attr.
	attr := Attribut
				name: 'name'
				dataType: 'string'
				quantity: '1'.
	person attributs add: attr.
	attr := Attribut
				name: 'dateOfBirth'
				dataType: 'date'
				quantity: '0..1'.
	person attributs add: attr.
	method := Method name: 'age' returnDataType: 'integer'.
	person methods add: method.
	animal := Kind name: 'Animal'.
	method := Method
				name: 'eat'
				returnDataType: 'boolean'
				abstract: true.
	method parameters add: 'food'.
	animal methods add: method.
	method := Method
				name: 'sound'
				returnDataType: 'string'
				instance: false.
	animal methods add: method.
	association := FormalAssociation
				name: 'has'
				start: person
				startQuantity: '1'
				end: animal
				endQuantity: '0..*'.
	person associations add: association.
	animal associations add: association.
	position := PositionClass
				leftTopPoint: (Point x: 15 y: 15)
				rightBottomPoint: (Point x: 215 y: 180).
	data
		add: (DataClass mmClass: person pClass: position).
	position := PositionClass
				leftTopPoint: (Point x: 415 y: 15)
				rightBottomPoint: (Point x: 540 y: 120).
	data
		add: (DataClass mmClass: animal pClass: position).
	position := PositionGroupOfLines new.
	position
		lines: (PositionLine
				leftTopPoint: (Point x: 215 y: 90)
				rightBottomPoint: (Point x: 415 y: 90)).
	data
		add: (DataClass mmClass: association pClass: position).
	DrawDiagram draw: data! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:47'!
end
	^ end! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:47'!
end: anObject
	end := anObject! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:47'!
endQuantity
	^ endQuantity! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:47'!
endQuantity: anObject
	endQuantity := anObject! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:48'!
name 	
	^name! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:48'!
name: xName
	name := xName! !

!AssociationWindow methodsFor: 'open' stamp: 'volosmat 11/27/2013 22:32'!
openModal
	| builder dialog content listModelStart listModelEnd listModelType |
 
	builder := UITheme builder.
	listModelStart := ListModel new list: #('Class1' 'Class2' 'Class3' ).
	listModelEnd := ListModel new list: #('Class1' 'Class2' 'Class3' ).
	listModelType := ListModel new list: #('Characterization' 'Derivation' 'Mediation' 'ComponentOf' 'MemberOf' 'SubCollectionOf'  'SubQuantityOf' 'FormalAssociation' 'MaterialAssociation').
 	content := (builder newLabelGroup: {
			'Type:'->(  builder 
						newDropListFor: listModelType
						list: #list 
						getSelected: #selectionIndex 
						setSelected: #selectionIndex: 
						help: 'Start class').
			'Start class:'->(  builder 
						newDropListFor: listModelStart
						list: #list 
						getSelected: #selectionIndex 
						setSelected: #selectionIndex: 
						help: 'Start class').
  			
  			'Start quantity:' ->(( builder
   						newTextEntryFor: self
						getText: #startQuantity  
						setText: #startQuantity: 
						help: 'Enter start quantity')
   					acceptOnCR: false;
   					minWidth: 200 ).
			'End class:'->(  builder 
						newDropListFor: listModelEnd
						list: #list 
						getSelected: #selectionIndex 
						setSelected: #selectionIndex: 
						help: 'Start class').
			'End quanitity:' ->(( builder
   						newTextEntryFor: self
						getText: #endQuantity  
						setText: #endQuantity: 
						help: 'Enter end quantity')
   					acceptOnCR: false;
   					minWidth: 200 ).
			'Name:' ->(( builder
   						newTextEntryFor: self
						getText: #name  
						setText: #name: 
						help: 'Enter name of association')
   					acceptOnCR: false;
   					minWidth: 200 ).
	}).
	dialog := builder newPluggableDialogWindow:'Create association' for: content.
	builder openModal: dialog.
	
 	listModelStart := listModelStart selectedItem.
	listModelEnd := listModelEnd selectedItem.
	listModelType := listModelType selectedItem.
	dialog cancelled ifFalse: [self doOnOK ].! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:47'!
start
	^ start! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:47'!
start: anObject
	start := anObject! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:48'!
startQuantity
	^ startQuantity! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:48'!
startQuantity: anObject
	startQuantity := anObject! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 19:52'!
type
	^ type! !

!AssociationWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 19:52'!
type: anObject
	type := anObject! !

Object subclass: #AttributWindow
	instanceVariableNames: 'name dataType instance quantity classList attributList delete'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!AttributWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 17:29'!
attributList
	^ attributList! !

!AttributWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 17:29'!
attributList: anObject
	attributList := anObject! !

!AttributWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 17:29'!
classList
	^ classList! !

!AttributWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 17:29'!
classList: anObject
	classList := anObject! !

!AttributWindow methodsFor: 'accessing' stamp: 'volosmat 11/25/2013 23:46'!
dataType
	^ dataType! !

!AttributWindow methodsFor: 'accessing' stamp: 'volosmat 11/25/2013 23:46'!
dataType: anObject
	dataType := anObject! !

!AttributWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 19:05'!
delete
	^ delete! !

!AttributWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 19:04'!
delete: anObject
	delete := anObject! !

!AttributWindow methodsFor: 'ok actions' stamp: 'volosmat 11/28/2013 21:16'!
doOnOK
	| class |
	name isNil | quantity isNil | dataType isNil | classList hasSelected not
		ifTrue: [^ GMF alertDialog: 'Error. All fields are required.'].
	class := (Facade getClass: classList selectedItem) metaModelClass.
	attributList hasSelected not
		ifTrue: [class attributs
				add: (Attribut
						name: name
						dataType: dataType
						quantity: quantity
						instance: instance)];
		
		ifFalse: [(class searchAttribut: attributList selectedItem) name: name;
				 dataType: dataType;
				 quantity: quantity;
				 instance: instance.
			delete
				ifTrue: [class removeAttribut: name]].
	DrawDiagram draw: Facade getDiagram.! !

!AttributWindow methodsFor: 'initialize-release' stamp: 'volosmat 11/27/2013 19:05'!
initialize 
	instance := true.
	delete := false.
	classList := ClassList new dialogWindow: self.
	attributList := AttributList new dialogWindow: self! !

!AttributWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 13:30'!
instance
	^ instance! !

!AttributWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 11:50'!
instance: anObject
	instance := anObject! !

!AttributWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 11:51'!
name
	^ name! !

!AttributWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 11:51'!
name: anObject
	name := anObject! !

!AttributWindow methodsFor: 'open' stamp: 'volosmat 11/27/2013 19:06'!
openModal
	| builder dialog content |
	builder := UITheme builder.
	
	content := builder newLabelGroup: {
			'Class:' -> (builder
							newDropListFor: classList
							list: #list
							getSelected: #selectedIndex
							setSelected: #selectedIndex:
							help: 'Attribut class'). 
			'Attribut:' -> (builder
							newDropListFor: attributList
							list: #list
							getSelected: #selectedIndex
							setSelected: #selectedIndex:
							help: 'Attribut'). 
			'Name:' -> ((builder
							newTextEntryFor: self
							getText: #name
							setText: #name:
							help: 'Enter attribut name') 
						acceptOnCR: false;
						minWidth: 200). 
			'Data type:' -> ((builder
							newTextEntryFor: self
							getText: #dataType
							setText: #dataType:
							help: 'Enter attribut data type') 
						acceptOnCR: false;
						minWidth: 200). 
			'Quantity:' -> ((builder
							newTextEntryFor: self
							getText: #quantity
							setText: #quantity:
							help: 'Enter attribut quantity') 
						acceptOnCR: false;
						minWidth: 200). 
			'Instance:' -> (builder
							newCheckboxFor: self
							getSelected: #instance
							setSelected: #instance:
							label: ''
							help: 'Instance attribut').
							
			'Delete:'->(builder 
						newCheckboxFor: self
						getSelected: #delete 
						setSelected: #delete: 
						label: '' 
						help: 'Delete attribut').
							}.
	dialog := builder newPluggableDialogWindow: 'Create attribut' for: content.
	builder openModal: dialog.
	dialog cancelled
		ifFalse: [self doOnOK]! !

!AttributWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 18:00'!
quantity
	^ quantity ifNil: [ quantity:= 1 ]! !

!AttributWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 11:51'!
quantity: anObject
	quantity := anObject! !

Object subclass: #ElementWindow
	instanceVariableNames: 'name parent type delete classList parentList parentListChoice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 19:07'!
delete
	^ delete! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 19:07'!
delete: anObject
	delete := anObject! !

!ElementWindow methodsFor: 'private' stamp: 'volosmat 11/28/2013 19:02'!
deleteParentFromList
	parentList selectionIndex > 0
		ifTrue: [parent removeAt: parentList selectionIndex.
			parentList selectionIndex: 0.
			parentList list: parent.
			parentList changed: #list]! !

!ElementWindow methodsFor: 'ok actions' stamp: 'volosmat 11/28/2013 21:16'!
doOnOK
	| element class |
	name isNil | type isNil
		ifTrue: [^ GMF alertDialog: 'Error. All fields are required.'].
	classList hasSelected not
		ifTrue: [element := Compiler evaluate: type , ' new'.
			element name: name.
			parent
				do: [:each | element parent: (Facade getClass: each) metaModelClass].
			Facade
				addClass: (DataClass mmClass: element pClass: PositionClass new)];
		
		ifFalse: [class := Facade getClass: classList selectedItem.
			class metaModelClass name: name.
			class metaModelClass parent removeAll.
			class metaModelClass disjoint removeAll.
			parent
				do: [:each | class metaModelClass parent: (Facade getClass: each) metaModelClass].
			delete
				ifTrue: [Facade removeClass: class]].

	DrawDiagram draw: Facade getDiagram.! !

!ElementWindow methodsFor: 'initialize-release' stamp: 'volosmat 11/28/2013 14:44'!
initialize
	delete := false.
	classList := ClassList new dialogWindow: self.
	parentListChoice := ParentList new dialogWindow: self.
	parent := OrderedCollection new.
	parentList := ListModel new list: parent.! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 11/7/2013 20:27'!
name
	^name! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 11/7/2013 20:29'!
name: xName
	name := xName! !

!ElementWindow methodsFor: 'open' stamp: 'volosmat 11/28/2013 15:03'!
openModal
	|builder dialog content listModel |
 
	builder := UITheme builder.
	
	listModel := ListModel new list: #('Kind' 'SubKind' 'Phase' 'Role' 'Mode' 'Role' 'Relator' 'RoleMixin' 'Mixin' 'Category' 'Collective' 'Quantity' );
					selectionIndex: 1.
	
 	content := (builder newLabelGroup: {
			'Action:'->(  builder 
						newDropListFor: classList
						list: #list 
						getSelected: #selectedIndex 
						setSelected: #selectedIndex: 
						help: 'Element type').
			'Type:'->(  builder 
						newDropListFor: listModel
						list: #list 
						getSelected: #selectionIndex 
						setSelected: #selectionIndex: 
						help: 'Element type').
			'Select parent:'->(  builder 
						newDropListFor: parentListChoice
						list: #list 
						getSelected: #selectedIndex 
						setSelected: #selectedIndex: 
						help: 'Element parent').
			'Parent List'->((builder newListFor: parentList
						list: #list 
						selected: #selectionIndex 
						changeSelected: #selectionIndex:
						help: 'Selected parents') 
					minWidth: 120).
			''->(builder newButtonFor: self 
						action: #deleteParentFromList 
						label: 'Delete parent' 
						help: 'Delete parent').
  			'Name:' ->(( builder
   						newTextEntryFor: self
						getText: #name 
						setText: #name: 
						help: 'Enter element name')
   					acceptOnCR: false;
   					minWidth: 200 ).
			'Delete:'->(builder 
						newCheckboxFor: self
						getSelected: #delete 
						setSelected: #delete: 
						label: '' 
						help: 'Instance attribut').
	}).
	dialog := builder newPluggableDialogWindow:'Create element' for: content.
	builder openModal: dialog.
	
 	type := listModel selectedItem.

	dialog cancelled ifFalse: [self doOnOK ].! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 11/28/2013 15:24'!
parent
	^ parent ifNil: [ parent := OrderedCollection new ]! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 11/28/2013 15:20'!
parent: anObject
	parent := anObject! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 11/28/2013 18:46'!
parentAdd: xParent
	[ parent detect: [ :each | each == xParent ] ]
		on: Error 
		do: [ ^parent add: xParent ].
		
	^ GMF alertDialog: 'Element ', xParent,' is already in collection element parents.'! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 11/28/2013 14:45'!
parentList
	^ parentList! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 11/28/2013 14:45'!
parentList: anObject
	parentList := anObject! !

!ElementWindow methodsFor: 'accessing' stamp: 'volosmat 11/7/2013 20:27'!
type
	^type! !

Object subclass: #GMFList
	instanceVariableNames: 'selectedIndex dialogWindow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

GMFList subclass: #AssociationList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!AssociationList methodsFor: 'list' stamp: 'volosmat 11/27/2013 23:06'!
list
	| associationsList |
	associationsList := OrderedCollection new.
	associationsList add: 'New association'.
	dialogWindow classList hasSelected
		ifTrue: [(Facade getClass: dialogWindow classList selectedItem) metaModelClass attributs 
				do: [:each | associationsList add: each name]].
	^ associationsList! !

GMFList subclass: #AttributList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!AttributList methodsFor: 'list' stamp: 'volosmat 11/27/2013 17:42'!
list
	| attributsList |
	attributsList := OrderedCollection new.
	attributsList add: 'New attribut'.
	dialogWindow classList hasSelected
		ifTrue: [(Facade getClass: dialogWindow classList selectedItem) metaModelClass attributs 
				do: [:each | attributsList add: each name]].
	^ attributsList! !

!AttributList methodsFor: 'list' stamp: 'volosmat 11/27/2013 17:38'!
selectedIndex: xIndex 
	| attribut |
	selectedIndex := xIndex.
	self hasSelected
		ifTrue: [attribut := (Facade getClass: dialogWindow classList selectedItem) metaModelClass searchAttribut: self selectedItem.
			dialogWindow name: attribut name.
			dialogWindow quantity: attribut quantity.
			dialogWindow dataType: attribut dataType.
			dialogWindow instance: attribut instance];
		
		ifFalse: [dialogWindow name: nil.
			dialogWindow quantity: 1.
			dialogWindow dataType: nil.
			dialogWindow instance: true].
	self changed: #selectedIndex;
		 changed: #hasSelected.
	dialogWindow changed: #name; 
		 changed: #quantity;
		 changed: #dataType;
		 changed: #instance! !

GMFList subclass: #ClassList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!ClassList methodsFor: 'list' stamp: 'volosmat 11/27/2013 16:00'!
list
	| classList |
	classList := OrderedCollection new.
	classList add: ''.
	Facade getClasses
		do: [:each | classList add: each metaModelClass name].
	^ classList ! !

!ClassList methodsFor: 'actions' stamp: 'volosmat 11/27/2013 21:07'!
selectedAttributAction
	dialogWindow attributList selectedIndex: 1. 
	dialogWindow name: nil.
	dialogWindow dataType: nil.
	dialogWindow quantity: 1.
	dialogWindow instance: true.
	self changed: #selectedIndex;
		 changed: #hasSelected.
	dialogWindow attributList changed: #list.
	dialogWindow changed: #name;
		 changed: #quantity;
		 changed: #dataType;
		 changed: #instance! !

!ClassList methodsFor: 'actions' stamp: 'volosmat 11/28/2013 19:03'!
selectedClassAction
	| class |
	dialogWindow parent: OrderedCollection new.
	self hasSelected
		ifTrue: [class := (Facade getClass: self selectedItem) metaModelClass.
			dialogWindow name: class name.
			dialogWindow parent: OrderedCollection new.
			class parent
				do: [:each | dialogWindow parentAdd: (Facade getClass: each name) metaModelClass name]];
		 
		ifFalse: [dialogWindow name: nil.].
	self changed: #selectedIndex.
	dialogWindow changed: #name.
	dialogWindow parentList list: dialogWindow parent.
	dialogWindow parentList changed: #list! !

!ClassList methodsFor: 'list' stamp: 'volosmat 11/27/2013 21:49'!
selectedIndex: xIndex 
	selectedIndex := xIndex.
	( dialogWindow isMemberOf: ElementWindow )
		ifTrue: [self selectedClassAction].
	( dialogWindow isMemberOf: AttributWindow )
		ifTrue: [self selectedAttributAction].
	( dialogWindow isMemberOf: MethodWindow )
		ifTrue: [self selectedMethodAction]! !

!ClassList methodsFor: 'actions' stamp: 'volosmat 11/27/2013 21:07'!
selectedMethodAction
	dialogWindow methodList selectedIndex: 1.
	dialogWindow name: nil. 
	dialogWindow returnDataType: nil.
	dialogWindow parameters: 'param1 param2 param3'.
	dialogWindow instance: true.
	dialogWindow abstract: false.
	self changed: #selectedIndex;
		 changed: #hasSelected.
	dialogWindow methodList changed: #list.
	dialogWindow changed: #name;
		 changed: #parameters;
		 changed: #returnDataType;
		 changed: #instance;
		 changed: #abstract! !

ClassList subclass: #ParentList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!ParentList methodsFor: 'list' stamp: 'volosmat 11/28/2013 17:14'!
selectedIndex: xIndex 
	selectedIndex := xIndex.
	
	self hasSelected
		ifTrue: [dialogWindow parentAdd: self selectedItem. ].
	self changed: #selectedIndex. 
	dialogWindow changed: #parent.
	dialogWindow parentList list: dialogWindow parent.
	dialogWindow parentList changed: #list
	
	! !

!GMFList methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 16:01'!
dialogWindow
	^ dialogWindow! !

!GMFList methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 16:01'!
dialogWindow: anObject
	dialogWindow := anObject! !

!GMFList methodsFor: 'list' stamp: 'volosmat 11/27/2013 17:34'!
hasSelected
	^ self selectedIndex > 1! !

!GMFList methodsFor: 'list' stamp: 'volosmat 11/27/2013 15:44'!
list
	^self subclassResponsibility.! !

!GMFList methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 15:42'!
selectedIndex
	^ selectedIndex ifNil: [ selectedIndex := 1 ]! !

!GMFList methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 15:43'!
selectedIndex: xIndex
	^ self subclassResponsibility! !

!GMFList methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 23:51'!
selectedItem
	^ self list at: self selectedIndex! !

GMFList subclass: #MethodList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!MethodList methodsFor: 'list' stamp: 'volosmat 11/27/2013 19:15'!
list
	| methodsList |
	methodsList := OrderedCollection new.
	methodsList add: 'New method'.
	dialogWindow classList hasSelected
		ifTrue: [(Facade getClass: dialogWindow classList selectedItem) metaModelClass methods 
				do: [:each | methodsList add: each name]].
	^ methodsList! !

!MethodList methodsFor: 'list' stamp: 'volosmat 11/27/2013 20:21'!
selectedIndex: xIndex 
	| method parameters |
	selectedIndex := xIndex.
	self hasSelected
		ifTrue: [method := (Facade getClass: dialogWindow classList selectedItem) metaModelClass searchMethod: self selectedItem.
			parameters := method parameters inject: '' into: [ :str :a | str , a asString, ' '. ].
			dialogWindow name: method name.
			dialogWindow returnDataType: method returnDataType.
			dialogWindow parameters: parameters.
			dialogWindow instance: method instance.
			dialogWindow abstract: method abstract];
		
		ifFalse: [dialogWindow name: nil.
			dialogWindow returnDataType: nil.
			dialogWindow parameters: 'param1 param2 param3'.
			dialogWindow instance: true.
			dialogWindow abstract: false].
	self changed: #selectedIndex;
		 changed: #hasSelected.
	dialogWindow changed: #name; 
		 changed: #parameters;
		 changed: #returnDataType;
		 changed: #instance;
		 changed: #abstract! !

Object subclass: #MethodWindow
	instanceVariableNames: 'returnDataType parameters instance abstract name classList methodList delete'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:44'!
abstract
	^ abstract! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:44'!
abstract: anObject
	abstract := anObject! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 19:24'!
classList
	^ classList! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 19:24'!
classList: anObject
	classList := anObject! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 19:11'!
delete
	^ delete! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 19:11'!
delete: anObject
	delete := anObject! !

!MethodWindow methodsFor: 'ok actions' stamp: 'volosmat 11/28/2013 23:03'!
doOnOK
	| class paramCol |
	name isNil | returnDataType isNil | classList hasSelected not
		ifTrue: [^ GMF alertDialog: 'Error. Required fields are name, class, return data type.'].
	class := (Facade getClass: classList selectedItem) metaModelClass.
	parameters notNil & parameters ~= ''
		ifTrue: [paramCol := ' ' split: parameters. 
			[(paramCol at: paramCol size) = '']
				whileTrue: [paramCol removeLast]]; 
		
		ifFalse: [paramCol := OrderedCollection new].
	methodList hasSelected not
		ifTrue: [class methods
				add: (Method
						name: name
						returnDataType: returnDataType
						abstract: abstract
						instance: instance
						parameters: paramCol)];
		
		ifFalse: [(class searchMethod: methodList selectedItem) name: name;
				 returnDataType: returnDataType;
				 abstract: abstract;
				 instance: instance;
				 parameters: paramCol.
			delete
				ifTrue: [class removeMethod: name]].
	DrawDiagram draw: Facade getDiagram! !

!MethodWindow methodsFor: 'initialize-release' stamp: 'volosmat 11/27/2013 19:25'!
initialize 
	delete := false.
	instance := true.
	abstract := false.
	classList := ClassList new dialogWindow: self.
	methodList := MethodList new dialogWindow: self.! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:44'!
instance
	^ instance! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:44'!
instance: anObject
	instance := anObject! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 19:24'!
methodList
	^ methodList! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/27/2013 19:24'!
methodList: anObject
	methodList := anObject! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:49'!
name
	^name! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:49'!
name: xName
	name := xName! !

!MethodWindow methodsFor: 'open' stamp: 'volosmat 11/27/2013 19:37'!
openModal
	| builder dialog content |
 
	builder := UITheme builder.

 	content := (builder newLabelGroup: {
			'Class:'->(  builder 
						newDropListFor: classList
						list: #list 
						getSelected: #selectedIndex 
						setSelected: #selectedIndex: 
						help: 'Method class').
			'Method:'->(  builder 
						newDropListFor: methodList
						list: #list 
						getSelected: #selectedIndex 
						setSelected: #selectedIndex: 
						help: 'Method').
  			'Name:' ->(( builder
   						newTextEntryFor: self
						getText: #name 
						setText: #name: 
						help: 'Enter attribut name')
   					acceptOnCR: false;
   					minWidth: 200 ).
			'Parameters:' ->(( builder
   						newTextEntryFor: self
						getText: #parameters 
						setText: #parameters: 
						help: 'Enter method parameters')
   					acceptOnCR: false;
   					minWidth: 200 ).
			'Return data type' ->(( builder
   						newTextEntryFor: self
						getText: #returnDataType  
						setText: #returnDataType: 
						help: 'Enter return data type')
   					acceptOnCR: false;
   					minWidth: 200 ).
			'Instance:'->(builder 
						newCheckboxFor: self
						getSelected: #instance 
						setSelected: #instance: 
						label: '' 
						help: 'Instance method').
			'Abstract:'->(builder 
						newCheckboxFor: self
						getSelected: #abstract 
						setSelected: #abstract: 
						label: '' 
						help: 'Abstract method').
			'Delete:'->(builder 
						newCheckboxFor: self
						getSelected: #delete 
						setSelected: #delete: 
						label: '' 
						help: 'Delete method').
	}).
	dialog := builder newPluggableDialogWindow:'Create method' for: content.
	builder openModal: dialog.

	dialog cancelled ifFalse: [self doOnOK ].! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:59'!
parameters
	^ parameters ifNil: [ ^'param1 param2 param3' ]! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:45'!
parameters: anObject
	parameters := anObject! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/28/2013 22:22'!
returnDataType
	^ returnDataType ifNil: [ returnDataType := 'void' ]! !

!MethodWindow methodsFor: 'accessing' stamp: 'volosmat 11/14/2013 17:45'!
returnDataType: anObject
	returnDataType := anObject! !
